#! /usr/bin/env python

import os
import glob
import distutils.core
import distutils.sysconfig
import distutils.command
from quixote.ptl.qx_distutils import qx_build_py

distutils.core.setup(
        name = 'wcs',
        version = "0.0.0",
        maintainer = "Frederic Peters",
        maintainer_email = "fpeters@entrouvert.com",
        url = "http://wcs.labs.libre-entreprise.org",
        package_dir = { 'wcs': 'wcs' },
        packages = ['wcs', 'wcs.admin', 'wcs.forms', 'wcs.liberty'],
        cmdclass = {'build_py': qx_build_py},
        scripts = ['wcs_scgi_server.py'],
        data_files = [('share/wcs/web/', ( 'root/index.html',)),
                ('share/wcs/web/css', tuple(
                    glob.glob('root/css/*.css') + \
                    glob.glob('root/css/*.jpg') + \
                    glob.glob('root/css/*.png'))),
                ('share/wcs/web/css/img', tuple(
                    glob.glob('root/css/img/*.jpg') + \
                    glob.glob('root/css/img/*.png'))),
                ]
    )
