APP_DIR = '/var/tmp/wcs'

import os
import lasso
import __builtin__

import storage
import gettext, locale

gettext.install('wcs')
_1 = _
__builtin__.__dict__['_'] = lambda x: unicode(_1(str(x)), 'utf-8').encode('iso-8859-1')
__builtin__.__dict__['N_'] = lambda x: x

if not os.path.exists(APP_DIR):
    os.mkdir(APP_DIR)

from quixote import enable_ptl, errors, get_session, redirect, get_session_manager
from quixote.publish import Publisher
from quixote.directory import Directory
enable_ptl()

import wcs.misc

import sessions

import admin.root
import forms.root
import liberty.root

class RootDirectory(Directory):
    _q_exports = ["", "admin", "forms", "login", "logout", "liberty"]

    def _q_index(self):
        return redirect('forms')

    def login(self):
        return self.liberty.login()

    def logout(self):
        get_session_manager().expire_session()
        redirect('.')

    admin = admin.root.RootDirectory()
    forms = forms.root.RootDirectory()
    liberty = liberty.root.RootDirectory()


class WcsPublisher(Publisher):
    def format_publish_error(self, exc):
        if isinstance(exc, errors.AccessError) and hasattr(exc, 'render'):
            return exc.render()
        return Publisher.format_publish_error(self, exc)

    def try_publish(self, request):
        # called for each request, should set APP_DIR here for a kind of
        # virtual hosting (set it from HTTP header, hostname, uri, whatever)
        global app_dir
        app_dir = wcs.APP_DIR + '/_TEST'
        wcs.misc.filename = os.path.join(app_dir, 'config.pck')
        wcs.misc.reload_cfg()
        storage.FilesStorage.BASEDIR = app_dir
        return Publisher.try_publish(self, request)
        

def create_publisher():
    session_manager = sessions.PickleSessionManager()

    return WcsPublisher(RootDirectory(),
            session_manager = session_manager,
            session_cookie_name = 'wcs',
            display_exceptions = 'plain',
            #error_email = "fpeters@entrouvert.com",
            session_cookie_path = '/')
