import cPickle
import re
import lasso

import wcs

def get_lasso_server():
    reload_cfg()
    if not cfg.has_key('sp'):
        return None
    server = lasso.Server(
        cfg['sp']['metadata'],
        cfg['sp']['privatekey'],
        None, None)
    for idp in cfg.get('idp', {}).values():
        server.addProvider(
                lasso.PROVIDER_ROLE_IDP,
                idp['metadata'],
                idp['publickey'],
                None)
    return server

def write_cfg():
    s = cPickle.dumps(cfg)
    file(filename, 'w').write(s)

def reload_cfg():
    global cfg
    try:
        cfg = cPickle.load(file(filename))
    except:
        cfg = {}

def get_provider_label(provider):
    if not hasattr(provider, str('getOrganization')):
        return provider.providerId

    organization = provider.getOrganization()
    if not organization:
        return provider.providerId

    name = re.findall("<OrganizationDisplayName.*>(.*?)</OrganizationDisplayName>", organization)
    if not name:
        name = re.findall("<OrganizationName.*>(.*?)</OrganizationName>", organization)
        if not name:
            return provider.providerId
    return name[0]

